package c64.tape;

public class C64TapImageMutator{

	public static final int PADDINGSIZE =  2500;
	public static final int INTRA 	    =     0;
	public static final int TRAIL       =   128;
	private static Object sourcedata;

	public static void setSourceData( Object obj ){
		sourcedata = obj;
	}

	static void addIntra( C64TapImage image, C64TapPrg prg, int i ){
		long prevsize = image.getTapImageSize( );
		long prgsize  = prg.getEndOffset( ) - prg.getStartOffset( ) + 1;

		image.changeTapImageSize( prgsize );

		long offset   = image.getTapImagePrg( i ).getStartOffset( );

		System.arraycopy( (Object)image.getTapImageData( ), (int)offset,
			(Object)image.getTapImageData( ), (int)(offset + prgsize), (int)(prevsize - offset) );

		System.arraycopy( sourcedata, (int)prg.getStartOffset( ),
			(Object)image.getTapImageData( ), (int)offset, (int)prgsize );

		C64TapPrg copy = new C64TapPrg( );
		copy.setName( prg.getName( ) );
		copy.setStartOffset( offset );
		offset += --prgsize;
		copy.setEndOffset( offset );

		image.addTapImagePrg( i, copy );

		C64TapPrg currPrg;
		prgsize++;

		for(int j=i+1; j<image.getTapImagePrgsCount(); j++)
		{
			currPrg = image.getTapImagePrg( j );
			currPrg.setStartOffset( currPrg.getStartOffset( ) + prgsize );
			currPrg.setEndOffset( currPrg.getEndOffset( ) + prgsize );
		}
	}

	static void addToTrail( C64TapImage image, C64TapPrg prg ){
		long prevsize = image.getTapImageSize( );
		long prgsize  = prg.getEndOffset( ) - prg.getStartOffset( ) + 1;

		image.changeTapImageSize( prgsize );

		System.arraycopy( sourcedata, (int)prg.getStartOffset( ),
			(Object)image.getTapImageData( ), (int)prevsize, (int)prgsize );

		C64TapPrg copy = new C64TapPrg( );
		copy.setName( prg.getName( ) );
		copy.setStartOffset( prevsize );

		prevsize+= --prgsize;
		copy.setEndOffset( prevsize );

		image.addTapImagePrg( copy );
	}

	static void deleteIntra( C64TapImage image, int i ){
		long prevsize = image.getTapImageSize( );
		C64TapPrg prg = image.getTapImagePrg( i );
		long prgsize  = prg.getEndOffset( ) - prg.getStartOffset( ) + 1;

		image.changeTapImageSize( -prgsize );

		System.arraycopy( (Object)image.getTapImageData( ), (int)prg.getEndOffset( ) + 1,
			(Object)image.getTapImageData( ), (int)prg.getStartOffset( ), (int)(prevsize -
				(prg.getEndOffset( ) + 1)) );

		image.removeTapImagePrg( i );

		C64TapPrg currPrg;

		for(int j=i; j<image.getTapImagePrgsCount(); j++)
		{
			currPrg = image.getTapImagePrg( j );
			currPrg.setStartOffset( currPrg.getStartOffset( ) - prgsize );
			currPrg.setEndOffset( currPrg.getEndOffset( ) - prgsize );
		}
	}

	static void deleteTrail( C64TapImage image ){
		int offset    = image.getTapImagePrgsCount( ) - 1;
		C64TapPrg prg = image.getTapImagePrg( offset );
		long prgsize  = prg.getEndOffset( ) - prg.getStartOffset( ) + 1;

		image.changeTapImageSize( -prgsize );

		image.removeTapImagePrg( offset );
	}
}
