package c64.tape;

import java.io.IOException;
import c64.tape.ex.EndOfTapFileException;

public class C64TapProcessor implements TapProcessor{
	private C64TapFile tapfile;
	private C64TapPrg tapprg;
	private Loader loader;
	private long start;

	public C64TapProcessor(C64TapFile file){
		tapfile=file;
	}

	public void searchForPrgs()throws IOException,EndOfTapFileException{
		loader=new KernelLoader(tapfile);

		try{
			do{
				start=loader.getHeader();
				if(tapprg!=null)
				tapprg.setEndOffset(start-1);
				tapprg=new C64TapPrg();
				tapprg.setStartOffset(start);
				tapprg.setName(loader.getName());
				tapfile.getTapImage().addTapImagePrg(tapprg);
				while(loader.getData()==4) manageSeqPrg();
				loader.getHeader();
			}while(true);
		}

		catch(EndOfTapFileException e){
			if(tapprg!=null)
				if(tapprg.getEndOffset()==0)
					tapprg.setEndOffset(tapfile.getTapFileOffset()-1);
			tapfile.close();
		}
	}

	private void manageSeqPrg()throws IOException,EndOfTapFileException{
		String name;

		do{
			loader.getHeader();
			name=loader.getName();
		}while(loader.getData()==2);

		tapprg.setEndOffset(tapfile.getTapFileOffset()-KernelLoader.BACKWARD-
			KernelLoader.TOREADAFTERSINCRO-1);
		tapprg=new C64TapPrg();
		tapprg.setName(name);
		tapprg.setStartOffset(tapfile.getTapFileOffset()-KernelLoader.BACKWARD-
			KernelLoader.TOREADAFTERSINCRO);
		tapfile.getTapImage().addTapImagePrg(tapprg);
	}
}
