 package gui;

 import javax.swing.*;
 import java.awt.BorderLayout;
 import java.awt.Dimension;
 import java.awt.GridBagLayout;
 import java.awt.GridBagConstraints;
 import java.awt.GridLayout;
 import java.awt.Toolkit;
 import java.awt.event.ActionListener;
 import java.awt.event.ActionEvent;
 import java.awt.event.WindowEvent;
 import java.awt.event.WindowListener;

 import conf.Configuration;

 public class MainFrame extends JFrame{
	 private JCheckBox move = new JCheckBox( "Sposta" );
	 private JButton save = new JButton( "Salva" );
	 private CustomPanel cp1;
	 private CustomPanel cp2;
	 private String pathTapFile1;
	 private String pathTapFile2;

	 public MainFrame( ){
		 Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		 int width   = d.width;
		 int height  = d.height;
		 setLocation( width/4, height/4 );
	     setSize( width/2, height/2 );
		 setTitle( "C64 TAPE MANAGER" );
		 setResizable( false );
		 addWindowListener( new CustomWindowListener( ) );
		 JPanel p1 = new JPanel( );
		 JPanel p2 = new JPanel( );
		 p1.setLayout( new GridLayout( 1, 2, 3, 3 ) );
		 p1.add( cp1 = new CustomPanel( this ) );
		 p1.add( cp2 = new CustomPanel( this ) );
		 p2.setLayout( new BorderLayout( ) );
		 p2.add( move, BorderLayout.WEST );
		 p2.add( save, BorderLayout.EAST );
		 getContentPane( ).setLayout( new BorderLayout( ) );
		 getContentPane( ).add( p1, BorderLayout.CENTER );
		 getContentPane( ).add( p2, BorderLayout.SOUTH );

		 save.addActionListener( new ActionListener( ){
		 	public void actionPerformed(ActionEvent e){
		 		 cp1.commitChanges( );
		 		 cp2.commitChanges( );
		 		}
			}
	 	 );

		 setVisible( true );
	 }

	 public boolean isMoveActive()
	 {
		 return move.isSelected();
	 }

	 public boolean isTheSameFile( CustomPanel panel, String path )
	 {

		 if( panel == cp1 )
		 {
			 if( pathTapFile2 == null )
			 {
				pathTapFile1 = path;
			 	return false;
			 }
			 else
			 {
			 	if( path.equals( pathTapFile2 ) )
			 		return true;
			 	else{
					pathTapFile2 = path;
					return false;
				}
			}
		 }

		 if( panel == cp2 )
		 {
			 if( pathTapFile1 == null )
			 {
				pathTapFile2 = path;
				return false;
			 }
			 else
			 {
				if( path.equals( pathTapFile1 ) )
			 		return true;

			 	else{
					pathTapFile2 = path;
					return false;
				}
		 	 }
		 }

		 return true;
	 }

	 private class CustomWindowListener implements WindowListener{

		 public void windowClosing( WindowEvent e ){
			 try
			 {
			 	Configuration.saveCurrentDir( );
			 }
			 catch(Exception ex)
			 {
				 ex.printStackTrace();
			 }
			 finally
			 {
			 	System.exit( 0 );
			}
		 }

		 public void windowClosed( WindowEvent e ){ }

		 public void windowActivated( WindowEvent e ){ }

		 public void windowDeactivated( WindowEvent e ){ }

		 public	void windowDeiconified( WindowEvent e ){ }

		 public void windowIconified( WindowEvent e ){ }

		 public void windowOpened( WindowEvent e ){ }
	 }
 }
